zoukankan      html  css  js  c++  java
  • Buy Tickets(线段树)

    Buy Tickets
    Time Limit: 4000MS   Memory Limit: 65536K
    Total Submissions: 16607   Accepted: 8275

    Description

    Railway tickets were difficult to buy around the Lunar New Year in China, so we must get up early and join a long queue…

    The Lunar New Year was approaching, but unluckily the Little Cat still had schedules going here and there. Now, he had to travel by train to Mianyang, Sichuan Province for the winter camp selection of the national team of Olympiad in Informatics.

    It was one o’clock a.m. and dark outside. Chill wind from the northwest did not scare off the people in the queue. The cold night gave the Little Cat a shiver. Why not find a problem to think about? That was none the less better than freezing to death!

    People kept jumping the queue. Since it was too dark around, such moves would not be discovered even by the people adjacent to the queue-jumpers. “If every person in the queue is assigned an integral value and all the information about those who have jumped the queue and where they stand after queue-jumping is given, can I find out the final order of people in the queue?” Thought the Little Cat.

    Input

    There will be several test cases in the input. Each test case consists of N + 1 lines where N (1 ≤ N ≤ 200,000) is given in the first line of the test case. The next N lines contain the pairs of values Posi and Vali in the increasing order of i (1 ≤ iN). For each i, the ranges and meanings of Posi and Vali are as follows:

    • Posi ∈ [0, i − 1] — The i-th person came to the queue and stood right behind the Posi-th person in the queue. The booking office was considered the 0th person and the person at the front of the queue was considered the first person in the queue.
    • Vali ∈ [0, 32767] — The i-th person was assigned the value Vali.

    There no blank lines between test cases. Proceed to the end of input.

    Output

    For each test cases, output a single line of space-separated integers which are the values of people in the order they stand in the queue.

    Sample Input

    4
    0 77
    1 51
    1 33
    2 69
    4
    0 20523
    1 19243
    1 3890
    0 31492

    Sample Output

    77 33 69 51
    31492 20523 3890 19243

    Hint

    The figure below shows how the Little Cat found out the final order of people in the queue described in the first test case of the sample input.

     
     
     

    题解:

    刚开始没理解题意,链表错了,

    题意:

    有n个人在火车站买票,由于天黑,所以你插队没人会看见,现在给出n个人的插队目标(允许自己前面有几个人),和他的价值(在这里没有用,只是在输出时用),让你求出n个人目标完成后,输出他们所对应的价值。

    因为当允许前面插得人一样的时候,后面的会查到前面;所以从后往前;

    代码:

    /*#include<cstdio>
    #include<iostream>
    #include<cstring>
    #include<cmath>
    #include<algorithm>
    #include<vector>
    using namespace std;
    #define mem(x,y) memset(x,y,sizeof(x))
    const int INF=0x3f3f3f3f;
    typedef long long LL;
    const int MAXN= 200010;
    int next[MAXN];
    int m[MAXN];
    int main(){
    	int N,cur;
    	while(~scanf("%d",&N)){
    		next[0]=0;mem(next,0);
    		for(int i=1;i<=N;i++){
    			scanf("%d%d",&cur,m+i);
    			next[i]=next[cur];
    			next[cur]=i;
    		}
    		for(int i=next[0];i!=0;i=next[i]){
    			printf("%d ",m[i]);
    		}puts("");
    	}
    	return 0;
    }*/
    #include<cstdio>
    #include<iostream>
    #include<cstring>
    #include<cmath>
    #include<algorithm>
    #include<vector>
    using namespace std;
    #define mem(x,y) memset(x,y,sizeof(x))
    #define L tree[root].l
    #define R tree[root].r
    #define V tree[root].v
    #define NUM tree[root].num
    #define lson root<<1,l,mid
    #define rson root<<1|1,mid+1,r
    #define NOW NUM=tree[root<<1].num+tree[root<<1|1].num;
    const int MAXN=200010;
    struct Node{
    	int l,r,num;
    };
    Node tree[1000000];
    const int INF=0x3f3f3f3f;
    typedef long long LL;
    int ans[MAXN],a[MAXN],b[MAXN],k;
    void made(int root,int l,int r){
    	L=l;R=r;
    	NUM=(r-l+1);
    	if(l==r)return;
    		int mid=(l+r)>>1;
    		made(lson);
    		made(rson);
    }
    void update(int root,int v,int pos){
    	if(L==R){
    		NUM=0;
    		ans[L]=v;
    		return;
    	}
    	else{
    		if(tree[root<<1].num>=pos)update(root<<1,v,pos);
    		else update(root<<1|1,v,pos-tree[root<<1].num);//应该减去左树的num。。。 
    		}
    		NOW;
    }
    int main(){
    	int N;
    	while(~scanf("%d",&N)){
    		made(1,1,N);
    		for(int i=0;i<N;i++){
    			scanf("%d%d",&a[i],&b[i]);
    		}
    		for(int i=N-1;i>=0;i--)update(1,b[i],a[i]+1);//加1 
    		for(int i=1;i<N;i++)printf("%d ",ans[i]);
    		printf("%d
    ",ans[N]);
    	}
    	return 0;
    }
    
  • 相关阅读:
    Poj 3177 Redundant Paths (双连通分支+节点统计)
    Uva 796 Critical Links (割边+排序)
    Lightoj 1020
    Flip Game---poj1753(状压+bfs)
    Best Cow Line---poj3617(贪心)
    滑雪---poj1088(动态规划+记忆化搜索)
    King's Quest---poj1904(连通图缩点)
    Steady Cow Assignment---poj3189(多重匹配+二分)
    B. Berland National Library---cf567B(set|模拟)
    HDU Today---hdu2112(最短路-_-坑在是无向图)
  • 原文地址:https://www.cnblogs.com/handsomecui/p/4989899.html
Copyright © 2011-2022 走看看